 A$ = "pyridine"
 DIM A(10, 10), S(10, 10)
 READ N                              ' N IS THE DIMENSION OF THE MATRIX
 DATA 6
 FOR I = 1 TO N                      ' MATRIX READ ROUTINE
  FOR J = 1 TO N
    IF I <> J THEN 120
   S(I, J) = 1
120  NEXT J: NEXT I
 ' INPUT ARRAY
160 READ I, J, F, Z                    ' INPUT ROW, COL, ELE, 0 IF NOT END
 DATA 1,1,.5,0,1,2,1.2,0,1,6,1.2,0,2,1,1.2,0,2,3,1,0,3,4,1,0,4,5,1,0,1,6,1.2,0,5,6,1,999
  A(I, J) = -F: A(J, I) = -F        ' INPUT 999 AFTER LAST ELEMENT
  IF Z = 0 THEN 160
 ' COMPUTE INITIAL NORM
 FOR I = 1 TO N
  FOR J = 1 TO N
   IF I = J THEN 260
    V = V + A(I, J) ^ 2
260  NEXT J: NEXT I
 V = SQR(V)
 ' COMPUTE FINAL NORM
 V1 = V * 1E-08
 ' COMPUTE THE THRESHOLD NORM
320 V = V / N
 ' SEARCH FOR PIVOT POSITION AND TEST VALUES AGAINST THE NORM
340 Q = 1
350 Q = Q + 1
 P = 0
370 P = P + 1
  IF A(P, Q) < 0 THEN 410
  IF A(P, Q) = 0 THEN 810
  IF A(P, Q) > 0 THEN 420
410  IF (-A(P, Q) - V) < 0 THEN 810 ELSE 430
420  IF (A(P, Q) - V) < 0 THEN 810
430 I1 = 1
 ' MATRIX ROTATION
 L = -A(P, Q)
 M = .5 * (A(P, P) - A(Q, Q))
  IF M < 0 THEN 490
   GOTO 510
490    S1 = -1
   GOTO 520
510    S1 = 1
520     O = S1 * L / SQR(L ^ 2 + M ^ 2)
     T = O / SQR(2 + 2 * SQR(1 - O ^ 2))
     C = SQR(1 - T ^ 2)
 ' TRANSFORM ELEMENTS
 FOR I = 1 TO N
  IF (I - P) = 0 THEN 640
  IF (I - Q) = 0 THEN 640
   B = A(P, I) * C - A(Q, I) * T
   B1 = A(P, I) * T + A(Q, I) * C
    A(P, I) = B
    A(Q, I) = B1
 ' ROTATE THE MATRIX
640   B = S(I, P) * C - S(I, Q) * T
   B1 = S(I, P) * T + S(I, Q) * C
    S(I, P) = B
    S(I, Q) = B1
 NEXT I
   B = A(P, P) * C ^ 2 + A(Q, Q) * T ^ 2 - 2 * A(P, Q) * T * C
   B1 = A(P, P) * T ^ 2 + A(Q, Q) * C ^ 2 + 2 * A(P, Q) * T * C
   B2 = (A(P, P) - A(Q, Q)) * C * T + A(P, Q) * (C ^ 2 - T ^ 2)
    A(P, P) = B
    A(Q, Q) = B1
    A(P, Q) = B2
    A(Q, P) = A(P, Q)
 ' TRANSFORM MATRIX
 FOR I = 1 TO N
    A(I, Q) = A(Q, I)
    A(I, P) = A(P, I)
 NEXT I
810  IF (P - Q + 1) < 0 THEN 370
  IF (Q - N) < 0 THEN 350
  IF I1 = 0 THEN 860
 I1 = 0
 GOTO 340
860  IF (V - V1) > 0 THEN 320
 FOR I = 1 TO N
  FOR J = 1 TO N
   IF (I - J) <> 0 THEN 960
    PRINT A$                    'START PRINT ROUTINE
    PRINT : PRINT
    PRINT "ROOT NO."; I; "="; A(I, J)
    FOR P = 1 TO N
     PRINT P, J, S(P, J)
    NEXT P
960 NEXT J: PRINT
 NEXT I: END


