' Program QLLSQ.BAS
 PRINT "Program QLLSQ.BAS"
' Linear Least Squares Fit Using QBASIC
  DIM R(100), X(100)
  DIM Y(100), D(100)
  INPUT N
 DATA .194,-34.2,.59,-31.8,.821,-30,1.208,-28
  FOR I = 1 TO N
    READ X(I), Y(I)
  NEXT I
  FOR I = 1 TO N
   S1 = S1 + X(I)
   S2 = S2 + Y(I)
   S3 = S3 + X(I) ^ 2
   S4 = S4 + X(I) * Y(I)
 NEXT I
 E = N * S3 - S1 ^ 2
 M = (N * S4 - S1 * S2) / E
 B = (S2 * S3 - S1 * S4) / E
 FOR I = 1 TO N
  D(I) = M * X(I) + B
  R(I) = Y(I) - D(I)
  S5 = S5 + R(I) ^ 2
 NEXT I
 C = N - 2
 G = SQR(S5 / C)
 X1 = -B / M
 PRINT N; "POINTS, FIT WITH STD DEV "; G
 PRINT "SLOPE = "; M; ",X INTERCEPT = "; X1; ", Y INTERCEPT ="; B
 PRINT
 PRINT "     X          Y               R                         YCALC"
 PRINT
 FOR I = 1 TO N
  PRINT "  "; X(I), Y(I), R(I); "     ", D(I)
 NEXT I
 PRINT
 PRINT
  END

