 'Program QQlSQ
 'Quadratic Least Squares Curve Fit using QBASIC
 CLS
 PRINT "Program QQLSQ"
 DATA 1.1,1.3,2.3,2.2,3.2,3.4,4.1,3.9,5.2,5.1,6.1,6.0,7.1,7.2,8.0,8.1
  'General purpose quadratic least squares curve fit
  DIM X(100), Y(100), Z(100)
  PRINT "How many data pairs"; : INPUT N
  FOR I = 1 TO N
   READ X(I), Y(I)
   S1 = S1 + X(I)
  S2 = S2 + Y(I)
  S3 = S3 + X(I) ^ 2
  S4 = S4 + X(I) ^ 3
  S5 = S5 + X(I) ^ 4
  S6 = S6 + X(I) * Y(I)
  S7 = S7 + X(I) ^ 2 * Y(I)
 NEXT I
 D = N * (S3 * S5 - S4 ^ 2) - S1 * (S1 * S5 - S3 * S4) + S3 * (S1 * S4 - S3 ^ 2)
 A = N * (S3 * S7 - S4 * S6) - S1 * (S1 * S7 - S3 * S6) + S2 * (S1 * S4 - S3 ^ 2)
 B = N * (S6 * S5 - S7 * S4) - S2 * (S1 * S5 - S3 * S4) + S3 * (S1 * S7 - S3 * S6)
 C = S2 * (S3 * S5 - S4 ^ 2) - S1 * (S6 * S5 - S4 * S7) + S3 * (S6 * S4 - S3 * S7)
 FOR I = 1 TO N
  Z(I) = A / D * X(I) ^ 2 + B / D * X(I) + C / D
  S8 = S8 + (Y(I) - Z(I)) ^ 2
 NEXT I
 PRINT "THE FOLLOWING DATA PAIRS WERE USED:"
 PRINT "  X            Y             YEXPECTED"
 FOR I = 1 TO N
  PRINT X(I), Y(I), Z(I)
 NEXT I
 PRINT "THE EQUATION OF THE PARABOLA IS:"
 PRINT "Y="; A / D; "X**2+("; B / D; ")X+("; C / D; ")"
 PRINT "THE STANDARD DEVIATION OF Y VALUES IS"; SQR(S8 / (N - 1))
 END

