'Program QLLVFR.BAS
 PRINT "Program QLLVFR.BAS"
 'QBASIC linear least squares curve fit to vibrational frequencies
  DIM R(100), x(100)
  DIM y(100), D(100)
  OPEN "A:VFREQ.DAT" FOR INPUT AS #1
  INPUT N
  FOR I = 1 TO N
  INPUT #1, x(I), y(I)
  NEXT I
  CLOSE #1
 FOR I = 1 TO N
   S1 = S1 + x(I)
   S2 = S2 + y(I)
   S3 = S3 + x(I) ^ 2
   S4 = S4 + x(I) * y(I)
 NEXT I
 E = N * S3 - S1 ^ 2
 M = (N * S4 - S1 * S2) / E
 B = (S2 * S3 - S1 * S4) / E
 FOR I = 1 TO N
  D(I) = M * x(I) + B
  R(I) = y(I) - D(I)
  S5 = S5 + R(I) ^ 2
 NEXT I
 C = N - 2
 G = SQR(S5 / C)
 X1 = -B / M
 PRINT N; "POINTS, FIT WITH STD DEV "; G
 PRINT "SLOPE = "; M; ",X INTERCEPT = "; X1; ", Y INTERCEPT ="; B
 PRINT
 PRINT "     X          Y               R           YCALC"
 PRINT
 FOR I = 1 TO N
 PRINT "  "; x(I), y(I), R(I); "  ", D(I)
 NEXT I
 PRINT
 PRINT
  END

