'PROGRAM NAME: THERMO(F) BY D. W. ROGERS
CLS
OPEN "A:THERMO.DAT" FOR OUTPUT AS #1
PRINT : PRINT #1, "Program THERMO.BAS by D. W. Rogers"
PRINT
'ENTER THE NAME OF THE COMPOUND
A$ = "BENZENE"
'ENTER THE NUMBER OF CARBONS AND HYDROGENS, C AND H.
c = 6
h = 6
'ENTER THE ENERGY AT 0K AND THE ENTHALPY AT 298K FROM THE GAUSSIAN OUTPUT.
e0K = -231.82975#
h298K = -231.8243#
'DATA INPUT COMPLETE
AT = (c * -37.78934) + (h * -.50184)
ekcal = 627.51 * (e0K - AT)
EF = ekcal + (c * 169.98) + (h * 51.63)
hkcal = 627.51 * (h298K - AT)
HF = hkcal + (c * 169.73) + (h * 50.62)
PRINT #1, A$
PRINT #1, "DELTA E OF FORMATION"; EF
PRINT #1, "DELTA H OF FORMATION"; HF
PRINT
END


